//+------------------------------------------------------------------+
//|                                      Williams Percent Range.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
//----
#property indicator_separate_window
#property indicator_minimum            0
#property indicator_maximum            100
#property indicator_buffers            3
#property indicator_color1             Blue
#property indicator_color2             Red
#property indicator_color3             Lime
#property indicator_level1             50
#property indicator_levelcolor         OrangeRed
#property indicator_levelstyle         2


//---- input parameters
extern int  ExtWPRPeriod                = 6;
//---- buffers
double      ExtWPRBuffer[];
double      buff_fWPR_High[];
double      buff_fWPR_Low[];
//---- variables
double      MaxHigh_1, MaxHigh_2, MaxHigh_3, MaxHigh_4, MaxHigh_5, MaxHigh_6;
double      MinLow_1, MinLow_2, MinLow_3, MinLow_4, MinLow_5, MinLow_6;
bool        LabelOn = true;
int         LabelPos = 20;
   double   dMaxHigh, dMinLow;
   double   fWPR_High, fWPR_Low;
   double   fWPR_HighMAX, fWPR_LowMin;
   string   WPR_Senario;
   double   WPR_1;
   string sShortName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffer mapping
   sShortName="kWPR(" + ExtWPRPeriod + ")";
   IndicatorShortName(sShortName);
   
   SetIndexBuffer    (0, ExtWPRBuffer);
   SetIndexStyle     (0, DRAW_LINE,0,0,Blue);
   SetIndexLabel     (0, sShortName);
   SetIndexDrawBegin (0, ExtWPRPeriod);
   
   SetIndexBuffer    (1, buff_fWPR_High);
   SetIndexStyle     (1, DRAW_LINE,2,0,Lime);
   SetIndexLabel     (1, "fHigh");

   SetIndexBuffer    (2, buff_fWPR_Low);
   SetIndexStyle     (2, DRAW_LINE,2,0,Red);
   SetIndexLabel     (2, "fLow");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Williams Percent Range                                          |
//+------------------------------------------------------------------+
int start()
  {
   int i, nLimit, nCountedBars;  
//---- insufficient data
   if(Bars <= ExtWPRPeriod) 
       return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars = IndicatorCounted();
//----Williams Percent Range calculation
   i = Bars - ExtWPRPeriod - 1;
   if(nCountedBars > ExtWPRPeriod) 
       i = Bars - nCountedBars - 1;  
   while(i >= 0)
     {
       double dMaxHigh = High[Highest(NULL, 0, MODE_HIGH, ExtWPRPeriod, i)];
       double dMinLow = Low[Lowest(NULL, 0, MODE_LOW, ExtWPRPeriod, i)];      
       if(!CompareDouble((dMaxHigh - dMinLow), 0.0))
           ExtWPRBuffer[i] = 100 - MathAbs(-100*(dMaxHigh - Close[i]) / (dMaxHigh - dMinLow));
       i--;       
     }
     
       ForecastWPR();
       buff_fWPR_High[0] = StrToDouble(DoubleToStr(fWPR_High,2));
       buff_fWPR_Low[0]  = StrToDouble(DoubleToStr(fWPR_Low,2));
     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|     .                        |
//+------------------------------------------------------------------+
bool CompareDouble(double Number1, double Number2)
  {
    bool Compare = NormalizeDouble(Number1 - Number2, 8) == 0;
    return(Compare);
  } 
//+------------------------------------------------------------------+ 
int ForecastWPR()
{

   LabelPos = 20;
   // The formula to calculate Williams Percent Range 
   // %R = (MAX (HIGH (i - n)) - CLOSE (i)) / (MAX (HIGH (i - n)) - MIN (LOW (i - n))) * 100
   // Where:
   // CLOSE (i) - the current close CurrentPrice;
   // MAX (HIGH (i - n)) - the highest top over the previous n periods;
   // MIN (LOW (i - n)) - the lowest bottom over the previous n periods


double MaxHigh_1, MaxHigh_2, MaxHigh_3, MaxHigh_4, MaxHigh_5, MaxHigh_6;
double MinLow_1, MinLow_2, MinLow_3, MinLow_4, MinLow_5, MinLow_6;

// Senarion One - Candle opens and goes 50 points pos
MaxHigh_1 = iLow (NULL,0,0) + (50*Point);
MaxHigh_2 = iHigh(NULL,0,1);
MaxHigh_3 = iHigh(NULL,0,2);
MaxHigh_4 = iHigh(NULL,0,3);
MaxHigh_5 = iHigh(NULL,0,4);
MaxHigh_6 = iHigh(NULL,0,5);

//Calculate Highs and Lows for WPR for WPR Period less 1
   dMaxHigh = 0; 
   dMaxHigh = MaxHigh_1;
if (MaxHigh_2 > dMaxHigh)
   {dMaxHigh = MaxHigh_2;}
if (MaxHigh_3 > dMaxHigh)
   {dMaxHigh = MaxHigh_3;}
if (MaxHigh_4 > dMaxHigh)
   {dMaxHigh = MaxHigh_4;}
if (MaxHigh_5 > dMaxHigh)
   {dMaxHigh = MaxHigh_5;}
if (MaxHigh_6 > dMaxHigh)
   {dMaxHigh = MaxHigh_6;}
   
MinLow_1 = iHigh(NULL,0,0) - (50*Point);
MinLow_2 = iLow (NULL,0,1);
MinLow_3 = iLow (NULL,0,2);
MinLow_4 = iLow (NULL,0,3);
MinLow_5 = iLow (NULL,0,4);
MinLow_6 = iLow (NULL,0,5);

   dMinLow = 0;
   dMinLow = MinLow_1;
if (MinLow_2 < dMinLow)
   {dMinLow = MinLow_2;}
if (MinLow_3 < dMinLow)
   {dMinLow = MinLow_3;}
if (MinLow_4 < dMinLow)
   {dMinLow = MinLow_4;}
if (MinLow_5 < dMinLow)
   {dMinLow = MinLow_5;}
if (MinLow_6 < dMinLow)
   {dMinLow = MinLow_6;}
      
   fWPR_High      = 0;
   fWPR_Low       = 0; 
   fWPR_HighMAX   = 0; 
   fWPR_LowMin    = 0; 

// A. SENARIO 1: CANDLE(0) TRADES POSITIVE  (Opens low closes +50 points)     
      // High = Open + 50 points
          
//       fWPR_HighMAX     = 100 - MathAbs( -100 * (dMaxHigh - (iOpen(NULL,0,0) + (50*Point)) ) / (dMaxHigh - dMinLow));   // Close is current CurrentPrice close
       fWPR_High        = 100 - MathAbs( -100 * (dMaxHigh - (iLow (NULL,0,0) + (50*Point)) ) / (dMaxHigh - dMinLow));   // Close is current CurrentPrice close

//      if (fWPR_HighMAX  > 100) {fWPR_HighMAX = 100;}
      if (fWPR_High     > 100) {fWPR_High    = 100;}
      
// B. SENARIO 2: CANDLE(0) TRADES NEGATIVE (Opens high closes -50 points) 
   // Low  = Open - 50 Point 
      
//       fWPR_LowMin      = 100 - MathAbs( -100 * (dMaxHigh - (iOpen(NULL,0,0) - (50*Point)) ) / (dMaxHigh - dMinLow));   // Close is current CurrentPrice close
       fWPR_Low         = 100 - MathAbs( -100 * (dMaxHigh - (iHigh(NULL,0,0) - (50*Point)) ) / (dMaxHigh - dMinLow));   // Close is current CurrentPrice close
//       if (fWPR_LowMin  < 0) {fWPR_LowMin = 0;}
       if (fWPR_Low     < 0) {fWPR_Low    = 0;}

       ObjectDelete  ("fWPR_High");
       ObjectCreate  ("fWPR_High",OBJ_HLINE,WindowFind(sShortName),0,fWPR_High,0,0);
       ObjectSet     ("fWPR_High",OBJPROP_STYLE, 3);
       ObjectSet     ("fWPR_High",OBJPROP_COLOR, RoyalBlue);
       
       ObjectDelete  ("fWPR_Low");
       ObjectCreate  ("fWPR_Low",OBJ_HLINE,WindowFind(sShortName),0,fWPR_Low,0,0);
       ObjectSet     ("fWPR_Low",OBJPROP_STYLE, 3);
       ObjectSet     ("fWPR_Low",OBJPROP_COLOR, Crimson);
       
   Label("Actual WPR High: ", DoubleToStr(fWPR_High,     2)   );
   LabelPos = LabelPos + 10; 
   Label("Actual WPR Low:  ", DoubleToStr(fWPR_Low,      2)    );
//   Label("MIN WPR:         ", DoubleToStr(fWPR_LowMin,   2)    );
   LabelPos = LabelPos + 10; 
   
   return(0);
}

//+------------------------------------------------------------------+
//| Labels                                                           |
//+------------------------------------------------------------------+
int Label(string p_text, string p_var) 

   { if (LabelOn == True)
     {
    // Create Label
       ObjectCreate  (p_text,23,0,0,0);
       ObjectSet     (p_text,OBJPROP_CORNER,1);
       ObjectSet     (p_text, OBJPROP_XDISTANCE, 5);
       ObjectSet     (p_text, OBJPROP_YDISTANCE, LabelPos);
       ObjectSetText (p_text,p_text + p_var, 10 , "Arial"  , Black);   
   
    // Increment lable position
       LabelPos = LabelPos + 12;
     }
}